package com.agendaonline.app;
import com.agendaonline.model.Paciente;
import com.agendaonline.model.Profissional;

import com.agendaonline.dao.*;

import java.sql.SQLException;
import java.util.List;
import java.util.Scanner;

import com.agendaonline.dao.PacienteDAOJDBC;
import com.agendaonline.model.Consultas;
import com.agendaonline.model.Pagamento;

public class AppTeste {

	public static void main(String[] args) {

		Paciente paciente = new Paciente();
		PacienteDAOJDBC db = new PacienteDAOJDBC();
		
		Scanner input = new Scanner(System.in);
		int op, id;
		String nome, cpf, data, email;
		
		do
		{
			System.out.println("1- Cadastrar Paciente");
			System.out.println("2- Alterar Paciente");
			System.out.println("3- Deletar Paciente");
			System.out.println("4- Consultar um Paciente");
			System.out.println("5- Consultar todos os Pacientes");
			System.out.println("6- Importar dados do XML para BD");
			System.out.println("7- Exportar dados do BD para XML");
			System.out.println("8- Sair");
			op = input.nextInt();
			
			switch(op)
			{
			
			case 1:
				System.out.print("Nome: ");
				nome = input.next();
				System.out.print("Email: ");
				email = input.next();
				System.out.print("CPF: ");
				cpf = input.next();
				System.out.print("Data: ");
				data = input.next();
				
				paciente.setNome(nome);
				paciente.setData(data);
				paciente.setCpf(cpf);
				paciente.setEmail(email);
				
				try {		
					db.cadastrar(paciente);
					System.out.println("Paciente cadastrado com sucesso!");
				} catch (SQLException e) {
					System.out.println(e.getMessage());
				}				
				break;
			case 2:
				System.out.println("ID:");
				id = input.nextInt();
				System.out.print("Novo Nome: ");
				nome = input.next();
				System.out.print("Novo Email: ");
				email = input.next();
				System.out.print("Novo CPF: ");
				cpf = input.next();
				System.out.print("Nova Data: ");
				data = input.next();
				
				paciente.setNome(nome);
				paciente.setEmail(email);
				paciente.setData(data);
				paciente.setCpf(cpf);
				
				try {		
					db.atualizar(paciente, id);;
					System.out.println("Paciente alterado com sucesso!");
				} catch (SQLException e) {
					System.out.println(e.getMessage());
				}
				break;
			case 3:
				System.out.println("ID:");
				id = input.nextInt();
				
				try {		
					db.removerPorId(id);
					System.out.println("Paciente deletado com sucesso!");
				} catch (SQLException e) {
					System.out.println(e.getMessage());
				}
				break;
			case 4:
				System.out.println("ID:");
				id = input.nextInt();
				try {		
				Paciente po = db.lerPorId(id);
					System.out.println("Nome: " + po.getNome());
					System.out.println("Email: " + po.getEmail());
					System.out.println("CPF: " + po.getCpf());
					System.out.println("Data: " + po.getData());
					System.out.print("\n");

					System.out.println("Consulta feita com sucesso!");
				} catch (SQLException e) {
					System.out.println(e.getMessage());
				}
				break;
			case 5:
				try {
					List<Paciente> pacientes = db.lerTodos();
					
					for (Paciente p : pacientes) {
						System.out.println("Nome: " + p.getNome());
						System.out.println("Email: " + p.getEmail());
						System.out.println("CPF: " + p.getCpf());
						System.out.println("Data: " + p.getData());	
						System.out.print("\n");
					}	
					System.out.println("Listagem concluida com sucesso!");
				} catch (SQLException e) {
					System.out.println(e.getMessage());
				}
				break;
			case 6:
				try{
					db.importarXML();
				}catch(Exception e) {
					System.out.println(e.getMessage());
				}	
				break;		
			case 7:
				try{
					db.exportarXML();
				}catch(Exception e) {
					System.out.println(e.getMessage());
				}	
				break;
			}
		}while(op != 8);
		
	}

}
