package com.agendaonline.app;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.List;
import java.util.Scanner;

import javax.persistence.EntityManager;

import com.agendaonline.dao.ConsultasDAO;
import com.agendaonline.dao.JpaUtil;
import com.agendaonline.dao.PacienteDAO;
import com.agendaonline.dao.PagamentoDAO;
import com.agendaonline.dao.ProfissionalDAO;
import com.agendaonline.model.Consultas;
import com.agendaonline.model.Paciente;
import com.agendaonline.model.Pagamento;
import com.agendaonline.model.Profissional;

public class AppTesteHibernate {

	public static void main(String[] args) {
		
		EntityManager manager = JpaUtil.getEntityManager();
		
		PacienteDAO pacdao = new PacienteDAO();
		ProfissionalDAO prodao = new ProfissionalDAO();
		ConsultasDAO condao = new ConsultasDAO();
		PagamentoDAO pagdao = new PagamentoDAO();
		
		Consultas consulta = new Consultas();
		Paciente paciente = new Paciente();
		Profissional profissional = new Profissional();
		
	    SimpleDateFormat sdf = new SimpleDateFormat( "HH:mm:ss" );
	    Calendar cal1 = Calendar.getInstance();
	    Calendar cal2 = Calendar.getInstance();
	    
	    cal1.set(Calendar.DAY_OF_MONTH, 1);
	    cal1.set(Calendar.MONTH, 10);
	    cal1.set(Calendar.YEAR, 1995);
	    
	    cal2.set(Calendar.HOUR_OF_DAY, 10);
	    cal2.set(Calendar.MINUTE, 23);
	    cal2.set(Calendar.SECOND, 15);	    
	    
	    Scanner input = new Scanner(System.in);
	    
	    // Grava os dados no banco
	    Profissional pr1 = new Profissional();
		pr1.setNome("Reinaldo");
		pr1.setBiografia("Medico formado em Harvard");
		pr1.setEspecialidade("Clinico Geral");
		pr1.setCr("47238964");
		manager.getTransaction().begin();
		manager.persist(pr1);
		manager.getTransaction().commit();
		
	    Profissional pr2 = new Profissional();
		pr2.setNome("Jorge");
		pr2.setBiografia("Medico formado na Unifenas");
		pr2.setEspecialidade("Residente");
		pr2.setCr("472553964");
		manager.getTransaction().begin();
		manager.persist(pr2);
		manager.getTransaction().commit();
		
		Paciente pa1 = new Paciente();
		pa1.setNome("Rhuan");
		pa1.setEmail("rhuangonzaga@gmail.com");
		manager.getTransaction().begin();
		manager.persist(pa1);
		manager.getTransaction().commit();
		
		Paciente pa2 = new Paciente();
		pa2.setNome("Ze");
		pa2.setEmail("ze@gmail.com");
		manager.getTransaction().begin();
		manager.persist(pa2);
		manager.getTransaction().commit();
		
		Pagamento p1 = new Pagamento();
		p1.setData(cal1.getTime());
		//p1.setPaciente(pa1);
		//p1.setConsulta(c1);
		//p1.setProfissional(pr1);
		p1.setFormaPagamento("Boleto Bancario");
		p1.setStatus("Pago");
		p1.setValor(40.00);
		manager.getTransaction().begin();
		manager.persist(p1);
		manager.getTransaction().commit();
		
		Pagamento p2 = new Pagamento();
		p2.setData(cal1.getTime());
		//p2.setPaciente(pa2);
		//p2.setConsulta(c2);
		//p2.setProfissional(pr1);
		p2.setFormaPagamento("Boleto Bancario");
		p2.setStatus("Pendente");
		p2.setValor(60.00);
		manager.getTransaction().begin();
		manager.persist(p2);
		manager.getTransaction().commit();
		// Fim grava os dados no banco
		
		Consultas c1 = new Consultas();
		c1.setPaciente(pa1);
		c1.setProfissional(pr1);
		c1.setPagamento(p1);
		c1.setData(cal1.getTime());
		c1.setHora(cal2.getTime());
		c1.setStatus("Agendado");
		manager.getTransaction().begin();
		manager.persist(c1);
		manager.getTransaction().commit();
		
		Consultas c2 = new Consultas();
		c2.setPaciente(pa2);
		c2.setProfissional(pr1);
		c2.setPagamento(p2);
		c2.setData(cal1.getTime());
		c2.setHora(cal2.getTime());
		c2.setStatus("Agendado");
		manager.getTransaction().begin();
		manager.persist(c2);
		manager.getTransaction().commit();
		
    	int op = 0;

	    do{
		    System.out.println("1 - Consultar todos pacientes");
		    System.out.println("2 - Consultar pacientes por id");
		    System.out.println("3 - Cadastrar paciente");
		    System.out.println("4 - Atualizar paciente");
		    System.out.println("5 - Apagar paciente");
	
		    System.out.println("6 - Consultar todos profissionais");
		    System.out.println("7 - Consultar profissionais por id");
		    System.out.println("8 - Cadastrar profissional");
		    System.out.println("9 - Atualizar profissional");
		    System.out.println("10 - Apagar profissional");
		    
		    System.out.println("11 - Listar todas consultas");
		    System.out.println("12 - Listar consulta por id");
		    System.out.println("13 - Listar consultas por paciente");
		    System.out.println("14 - Listar consultas por profissional");
		    System.out.println("15 - Cadastrar consulta");
		    System.out.println("16 - Atualizar consulta");
		    System.out.println("17 - Apagar consulta");
		    System.out.println("18 - Consultar todos pagamentos");
		    System.out.println("19 - Consultar pagamentos por id");
		    System.out.println("20 - Consultar pagamentos por paciente");
		    System.out.println("21 - Consultar pagamentos por profissional");
		    System.out.println("22 - Cadastrar pagamento");
		    System.out.println("23 - Atualizar pagamento");
		    System.out.println("24 - Apagar pagamento");
		    System.out.println("25 - Sair");
		    System.out.println("Sua opcao: ");
		    op = input.nextInt();
	
		    switch(op)
		    {
		    case 1: // Consultar todos pacientes
		    	
				for (Paciente pac : pacdao.getTodosPacientes()) {
					System.out.println("ID: " + pac.getId());
					System.out.println("Nome: " + pac.getNome());
					System.out.println("Email: " + pac.getEmail());
					System.out.println("-----------------------------");
				}
				input.next();
		    	break;
		    case 2: // Consultar pacientes por id
		    	Paciente pacobj = pacdao.getPacientePorId(1);
				System.out.println("ID: " + pacobj.getId());
				System.out.println("Nome: " + pacobj.getNome());
				System.out.println("Email: " + pacobj.getEmail());
				System.out.println("-----------------------------");
				input.next();
		    	break;		    	
		    case 3: // Cadastrar paciente
				paciente.setNome("Alfredo");
				paciente.setEmail("alfredo@gmail.com");
				pacdao.novoPaciente(paciente);
		    	System.out.println("Paciente cadastrado com sucesso!");
				input.next();
		    	break;
		    case 4: // Atualizar paciente
		    	paciente.setId(3);
				paciente.setNome("Jair");
				paciente.setEmail("jair@gmail.com");
				pacdao.atualizarPaciente(paciente);
		    	System.out.println("Paciente atualizado com sucesso!");
		    	input.next();
		    	break;
		    case 5: // Apagar paciente
		    	pacdao.apagarPaciente(paciente, 1);
		    	System.out.println("Paciente deletado com sucesso!");
		    	input.next();
		    	break;
		    case 6: // Consultar todos profissionais
				for (Profissional pro : prodao.getTodosProfissionals()) {
					System.out.println("ID: " + pro.getId());
					System.out.println("Nome: " + pro.getNome());
					System.out.println("Especialidade: " + pro.getEspecialidade());
					System.out.println("-----------------------------");
				}
				input.next();
		    	break;
		    case 7: // Consultar profissionais por id
		    	Profissional proobj = prodao.getProfissionalPorId(1);
				System.out.println("ID: " + proobj.getId());
				System.out.println("Nome: " + proobj.getNome());
				System.out.println("Especialidade: " + proobj.getEspecialidade());
				System.out.println("-----------------------------");
				input.next();
		    	break;
		    case 8: // Cadastrar profissional
				profissional.setNome("Carlos");
				profissional.setEspecialidade("Neurocirurgiao");
				prodao.novoProfissional(profissional);
		    	System.out.println("Profissional cadastrado com sucesso!");
				input.next();
		    	break;
		    case 9: // Atualizar profissional
		    	profissional.setId(3);
		    	profissional.setNome("Carlos");
		    	profissional.setEspecialidade("Ortopedista");
				pacdao.atualizarPaciente(paciente);
		    	System.out.println("Profissional atualizado com sucesso!");
		    	input.next();
		    	break;
		    case 10: // Apagar profissional
		    	prodao.apagarProfissional(profissional, 3);
		    	System.out.println("Profissional deletado com sucesso!");
		    	input.next();
		    	break;
		    case 11: // Listar todas consultas
		    	
				for (Consultas con : condao.getTodasConsultas()) {				
					System.out.println("Profissional: " + con.getProfissional().getNome());
					System.out.println("Paciente: " + con.getPaciente().getNome());
					System.out.println("Status: " + con.getStatus());
					System.out.println("-----------------------------");
				}
				input.next();
		    	break;
		    case 12: // Listar consulta por id
		    	Consultas consultaobj = condao.getConsultaPorId(1);
		   	
				System.out.println("ID: " + consultaobj.getId());
				System.out.println("Profissional: " + consultaobj.getProfissional().getNome());
				System.out.println("Paciente: " + consultaobj.getPaciente().getNome());
				System.out.println("Status: " + consultaobj.getStatus());
				System.out.println("-----------------------------");
				input.next();
		    	break;
		    case 13: // Listar consultas por paciente
		    	
				for (Consultas con : condao.getConsultasPaciente(1)) {		
					System.out.println("Profissional: " + con.getProfissional().getNome());
					System.out.println("Paciente: " + con.getPaciente().getNome());
					System.out.println("Status: " + con.getStatus());
					System.out.println("-----------------------------");
				}
				input.next();
		    	break;
		    case 14: // Listar consultas por profissional
		    	
				for (Consultas con : condao.getConsultasProfissional(1)) {				
					System.out.println("Profissional: " + con.getProfissional().getNome());
					System.out.println("Paciente: " + con.getPaciente().getNome());
					System.out.println("Status: " + con.getStatus());
					System.out.println("-----------------------------");
				}
				input.next();
		    	break;
		    case 15: // Cadastrar consulta
				consulta.setPaciente(pa1);
				consulta.setProfissional(pr2);
				consulta.setPagamento(p1);
				consulta.setData(cal1.getTime());
				consulta.setHora(cal2.getTime());
				consulta.setStatus("Agendado");
		    	condao.novaConsulta(consulta);
		    	System.out.println("Consulta cadastrada com sucesso!");
				input.next();
		    	break;
		    case 16: // Atualizar consulta
				consulta.setPaciente(pa1);
				consulta.setProfissional(pr1);
				consulta.setPagamento(p1);
				consulta.setData(cal1.getTime());
				consulta.setHora(cal2.getTime());
				consulta.setStatus("Completo");
		    	condao.atualizarConsulta(consulta, 3);
		    	System.out.println("Consulta atualizada com sucesso!");
				input.next();
		    	break;
		    case 17: // Apagar consulta
		    	condao.apagarConsulta(consulta, 3);
		    	System.out.println("Consulta deletada com sucesso!");
				input.next();
		    	break;
		    case 18: // Consultar todos pagamentos
				for (Pagamento pag : pagdao.consultarTodos()) {				
					System.out.println("Status: " + pag.getStatus());
					System.out.println("Valor: " +pag.getValor());
					System.out.println("Forma de pagamento: " + pag.getFormaPagamento());
					System.out.println("-----------------------------");
				}
				input.next();
		    	break;
		    case 19: // Consultar pagamentos por id
		    	break;
		    case 20: // Consultar pagamentos por paciente
		    	break;
		    case 21: // Consultar pagamentos por profissional
		    	break;
		    case 22: // Cadastrar pagamento
		    	break;
		    case 23: // Atualizar pagamento
		    	break;
		    case 24: // Apagar pagamento
		    	break;
		    }
	    }while(op != 25); // Sair
	    
		manager.close();
		JpaUtil.close();

		
	}

}
