package com.agendaonline.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.TypedQuery;

import com.agendaonline.model.Consultas;

public class ConsultasDAO {
	
	EntityManager manager = JpaUtil.getEntityManager();
	Query query;
	
	public List<Consultas> getTodasConsultas()
	{
		query = manager.createQuery("FROM Consultas");
		return query.getResultList();
	}
	
	public List<Consultas> getConsultasProfissional(int id)
	{
		query = manager.createQuery("FROM Consultas c WHERE c.profissional.id = :id");
		query.setParameter("id", id);
		return query.getResultList();
	}
	
	public List<Consultas> getConsultasPaciente(int id)
	{
		query = manager.createQuery("FROM Consultas c WHERE c.paciente.id = :id");
		query.setParameter("id", id);
		return query.getResultList();
	}
	
	public Consultas getConsultaPorId(int id)
	{	
		return manager.find(Consultas.class, id);
		
	    // query = manager.createQuery("from Consultas c WHERE c.id = :id");
		// return (Consultas) query.setParameter("id", id).getSingleResult();
	}
	
	public void novaConsulta(Consultas consulta){
		try {
			manager.getTransaction().begin();
			manager.persist(consulta);
			manager.getTransaction().commit();
		} catch (Exception ex) {
			ex.printStackTrace();
			manager.getTransaction().rollback();
		}
	}
	
    public void atualizarConsulta(Consultas consulta, int id) {
        try {
                 manager.getTransaction().begin();
                 consulta = manager.find(Consultas.class, id);
                 manager.merge(consulta);
                 manager.getTransaction().commit();
        } catch (Exception ex) {
                 ex.printStackTrace();
                 manager.getTransaction().rollback();
        }
    }
    
    public void apagarConsulta(Consultas consulta, int id) {
        try {
                 manager.getTransaction().begin();
                 consulta = manager.find(Consultas.class, id);
                 manager.remove(consulta);
                 manager.getTransaction().commit();
        } catch (Exception ex) {
                 ex.printStackTrace();
                 manager.getTransaction().rollback();
        }
    }
}
