package com.agendaonline.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import com.agendaonline.model.Paciente;

public class PacienteDAO {
	EntityManager manager = JpaUtil.getEntityManager();
	Query query;
	
	public List<Paciente> getTodosPacientes()
	{
		query = manager.createQuery("FROM Paciente");
		return query.getResultList();
	}
	
	public Paciente getPacientePorId(int id)
	{			
		Paciente paciente;
		paciente = manager.find(Paciente.class, id);
		return paciente;
		
	    // query = manager.createQuery("from Consultas c WHERE c.id = :id");
		// return (Consultas) query.setParameter("id", id).getSingleResult();
	}
	
	public void novoPaciente(Paciente paciente){
		try {
			manager.getTransaction().begin();
			manager.persist(paciente);
			manager.getTransaction().commit();
		} catch (Exception ex) {
			ex.printStackTrace();
			manager.getTransaction().rollback();
		}
	}
	
    public void atualizarPaciente(Paciente paciente) {
        try {
                 manager.getTransaction().begin();
                 manager.merge(paciente);
                 manager.getTransaction().commit();
        } catch (Exception ex) {
                 ex.printStackTrace();
                 manager.getTransaction().rollback();
        }
    }
    
    public void apagarPaciente(Paciente paciente, int id) {
        try {
                 manager.getTransaction().begin();
                 paciente = manager.find(Paciente.class, id);
                 manager.remove(paciente);
                 manager.getTransaction().commit();
        } catch (Exception ex) {
                 ex.printStackTrace();
                 manager.getTransaction().rollback();
        }
    }

}
