package com.agendaonline.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import com.agendaonline.model.Profissional;

public class ProfissionalDAO {
	EntityManager manager = JpaUtil.getEntityManager();
	Query query;
	
	public List<Profissional> getTodosProfissionals()
	{
		query = manager.createQuery("FROM Profissional");
		return query.getResultList();
	}
	
	public Profissional getProfissionalPorId(int id)
	{			
		Profissional profissional;
		profissional = manager.find(Profissional.class, id);
		return profissional;
		
	    // query = manager.createQuery("from Consultas c WHERE c.id = :id");
		// return (Consultas) query.setParameter("id", id).getSingleResult();
	}
	
	public void novoProfissional(Profissional profissional){
		try {
			manager.getTransaction().begin();
			manager.persist(profissional);
			manager.getTransaction().commit();
		} catch (Exception ex) {
			ex.printStackTrace();
			manager.getTransaction().rollback();
		}
	}
	
    public void atualizarProfissional(Profissional profissional) {
        try {
                 manager.getTransaction().begin();
                 manager.merge(profissional);
                 manager.getTransaction().commit();
        } catch (Exception ex) {
                 ex.printStackTrace();
                 manager.getTransaction().rollback();
        }
    }
    
    public void apagarProfissional(Profissional profissional, int id) {
        try {
                 manager.getTransaction().begin();
                 profissional = manager.find(Profissional.class, id);
                 manager.remove(profissional);
                 manager.getTransaction().commit();
        } catch (Exception ex) {
                 ex.printStackTrace();
                 manager.getTransaction().rollback();
        }
    }

}
