package com.agendaonline.model;

import javax.persistence.Entity;
import javax.persistence.Table;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
@Table(name = "tbl_paciente")
public class Paciente {
	@Id
	@GeneratedValue
	private int id;
	
	@Column(length = 60, nullable = false)
	private String nome;

	@Column(length = 60, nullable = true)
	private String data;
	
	@Column(length = 60, nullable = true)
	private String cpf;
	
	@Column(length = 60, nullable = true)
	private String rg;
	
	@Column(length = 60, nullable = true)
	private String cel;
	
	@Column(length = 60, nullable = true)
	private String email;

	@Column(length = 60, nullable = true)
	private String end;
	
	@Column(length = 60, nullable = true)
	private String num;
	
	@Column(length = 60, nullable = true)
	private String bairro;
	
	@Column(length = 60, nullable = true)
	private String cidade;
	
	@Column(length = 60, nullable = true)
	private String cep;
	
	@Column(length = 60, nullable = true)
	private String estado;
	
	@OneToMany(mappedBy="paciente", cascade=CascadeType.REMOVE)
	private List<Consultas> consultas;
		
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getData() {
		return data;
	}
	public void setData(String data) {
		this.data = data;
	}
	public String getCpf() {
		return cpf;
	}
	public void setCpf(String cpf) {
		this.cpf = cpf;
	}
	public String getRg() {
		return rg;
	}
	public void setRg(String rg) {
		this.rg = rg;
	}
	public String getCel() {
		return cel;
	}
	public void setCel(String cel) {
		this.cel = cel;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getEnd() {
		return end;
	}
	public void setEnd(String end) {
		this.end = end;
	}
	public String getNum() {
		return num;
	}
	public void setNum(String num) {
		this.num = num;
	}
	public String getBairro() {
		return bairro;
	}
	public void setBairro(String bairro) {
		this.bairro = bairro;
	}
	public String getCidade() {
		return cidade;
	}
	public void setCidade(String cidade) {
		this.cidade = cidade;
	}
	public String getCep() {
		return cep;
	}
	public void setCep(String cep) {
		this.cep = cep;
	}
	public String getEstado() {
		return estado;
	}
	public void setEstado(String estado) {
		this.estado = estado;
	}
	public List<Consultas> getConsultas() {
		return consultas;
	}
	public void setConsultas(List<Consultas> consultas) {
		this.consultas = consultas;
	}
}
